// ====================================================================================================
//
// Author  : mashimonator
// Create  : 2009/03/01
// Update  : 2009/03/01
// Description : 指定されたIDを持つ要素をドラッグ可能にする
//
// ====================================================================================================


var draggable_dragObject = null;
var draggable_mouseOffset = null;

var draggable = {

	//-----------------------------------------
	// 設定値
	//-----------------------------------------
	conf : {
		// 対象とする要素のID
		targetItem : [
					'dd-demo-1',
					'dd-demo-2',
					'dd-demo-3',
					'dd-demo-4',
					'dd-demo-5',
					'dd-demo-6'
					]
	},


	//-----------------------------------------
	// main処理
	//-----------------------------------------
	makeDraggable : function() {
		var elements = draggable.conf.targetItem;
		for (var i = 0; i < elements.length; i++) {
			item = document.getElementById(elements[i]);
			item.onmousedown = function(evnt){
				draggable_dragObject = this;
				draggable_mouseOffset = draggable.getMouseOffset(this,evnt);
				return false;
			}
			item.style.cursor = 'move';
		}
	},


	//-----------------------------------------
	// ﾏｳｽの動きとｸﾘｯｸの解放を見て､処理を実行する
	//-----------------------------------------
	mouseMove : function(evnt){ //evntはﾏｳｽの座標位置を持つ
		if(!draggable_dragObject) return;
		evnt = evnt || window.event;
		var mousePos = draggable.mousePosition(evnt);
		if(draggable_dragObject){
			draggable_dragObject.style.position = 'absolute';
			draggable_dragObject.style.top = mousePos.y - draggable_mouseOffset.y + "px";
			draggable_dragObject.style.left = mousePos.x - draggable_mouseOffset.x + "px";
			return false;
		}
	},


	//-----------------------------------------
	// ﾄﾞﾗｯｸﾞ"されている"なら､ﾏｳｽの座標をDOMで上書き絶対位置表示
	//-----------------------------------------
	mousePosition : function(evnt){
		var x = parseInt(evnt.clientX);
		var y = parseInt(evnt.clientY);
		return new draggable.mousePoint(x,y);
	},


	//-----------------------------------------
	// ﾏｳｽの座標をｳｨﾝﾄﾞｳ内の整数座標に整理
	//-----------------------------------------
	getMouseOffset : function(target,evnt){
		evnt = evnt || window.event;
		var mousePos = draggable.mousePosition(evnt);
		var x = mousePos.x - target.offsetLeft;
		var y = mousePos.y - target.offsetTop;
		return new draggable.mousePoint(x,y);
	},


	//-----------------------------------------
	// 最初に読み込まれるFunc､image上でﾏｳｽが押入されたら､getMouseoffsetを実行
	//-----------------------------------------
	mousePoint : function(x,y){
		this.x = x;
		this.y = y;
	},


	//-----------------------------------------
	// ﾏｳｽの座標を取得直し
	//-----------------------------------------
	mouseUp : function(evnt){
		draggable_dragObject = null;
	},


	//-----------------------------------------
	// イベントに追加
	//-----------------------------------------
	addEvent : function(event, element, func) {
		try {
			element.addEventListener(event, func, false);
		} catch (e) {
			element.attachEvent('on'+event, func);
		}
	},


	//-----------------------------------------
	// Loadイベントに追加
	//-----------------------------------------
	addLoadEvent : function() {
		try {
			window.addEventListener('load', this.makeDraggable, false);
		} catch (e) {
			window.attachEvent('onload', this.makeDraggable);
		}
	}

}

draggable.addLoadEvent();
draggable.addEvent('mousemove', document, draggable.mouseMove);
draggable.addEvent('mouseup', document, draggable.mouseUp);
